//
//  XXXDBManager.m
//  SQLiteDemo
//
//  Created by  SQLite+ on 10/27/11.
//  Copyright (c) http://www.iosxtools.com All rights reserved.
//
#import "XXXDBManager.h"
@interface XXXDBManager ()
- (NSString*)defaultDBPath;
@end
@implementation XXXDBManager
+ (XXXDBManager *)sharedXXXDBManager;
{
    static XXXDBManager *instace = nil;
    static dispatch_once_t oncePredicate;
    dispatch_once(&oncePredicate, ^{
        instace = [[super alloc] init];
    });
    return instace;
}
- (BOOL)openDataBaseInBundle:(NSString*)dataBase
{
    self.dbName = dataBase;
    NSString *dbPath = [self defaultBundlePath];
    return [self openDataBaseWithPath:dbPath];
}
- (BOOL)openDataBase:(NSString*)dataBase{
    self.dbName = dataBase;
    NSString *dbPath = [self defaultDBPath];
    return [self openDataBaseWithPath:dbPath];
}
- (BOOL)openDataBaseWithPath:(NSString*)path;
{
    NSLog(@"dbPath= %@ \n",path);
    self.queue = [FMDatabaseQueue databaseQueueWithPath:path];
    if(self.queue==0x00){
        NSLog(@"error opening the database with queue!");
        return NO;
    }
    else{
        [self.queue inDatabase:^(FMDatabase *db){
            [db setShouldCacheStatements:YES];
        }];
    }
    return YES;
}
- (void)closeDataBase{
    [_db close];
}
- (NSString*)defaultBundlePath{
    
    NSBundle * bundle = [NSBundle bundleForClass :[self class]];
    NSString * path = [bundle pathForResource :self.dbName ofType : nil];
    return path;	
}
- (NSString*)defaultDBPath{
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDirectory = [paths objectAtIndex:0];
    NSString *path = [documentsDirectory stringByAppendingPathComponent:self.dbName];
    return path;
}
@end
